import 'dart:io';

import 'package:transmedika_one_to_one_call/usecase/socket_usecase_service.dart';
/*import '../websocket/websocket.dart'
if (dart.library.js) '../websocket/websocket_web.dart';*/
import '../websocket/websocket.dart';

class SocketUseCase implements SocketUseCaseService{

  late SimpleWebSocket socket;

  @override
  Future<void> connect({
    required String url,
    required Function()? onOpen,
    required Function(dynamic)? onMessage,
    required Function(int? code, String? reason)? onClose}) async {
    try{
      socket = SimpleWebSocket(url);
      socket.onOpen = () {
        onOpen?.call();
      };

      socket.onMessage = (message) {
        onMessage?.call(message);
      };

      socket.onClose = (int? code, String? reason) {
        onClose?.call(code, reason);
      };

      await socket.connect();
    }on SocketException catch(e){
      onClose?.call(e.osError?.errorCode, e.osError?.message);
    }
  }

  @override
  SimpleWebSocket getSocket() {
    return socket;
  }

  @override
  Future<void> close() async {
    await socket.close();
  }

}