import 'package:equatable/equatable.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter_webrtc/flutter_webrtc.dart';
import 'package:transmedika_one_to_one_call/webrtc/one_to_one/models/profile.dart';

@immutable
abstract class OneToOneUiUIEvent extends Equatable{
  @override
  List<Object> get props => [];
}

@immutable
class OnConnectToSocket extends OneToOneUiUIEvent {
  OnConnectToSocket({
    required this.host,
    required this.from,
    required this.to,
    required this.isCalling,
    required this.consultationId,
    required this.mySelf,
    required this.other
  });
  final String host;
  final String from;
  final String to;
  final bool isCalling;
  final String consultationId;
  final Profile mySelf;
  final Profile other;
}

@immutable
class OnSocketOpen extends OneToOneUiUIEvent {}

@immutable
class OnCallAccepted extends OneToOneUiUIEvent {}

@immutable
class OnCallRejected extends OneToOneUiUIEvent {}

@immutable
class OnStopCall extends OneToOneUiUIEvent {}

@immutable
class OnMute extends OneToOneUiUIEvent {}

@immutable
class OnSwitchCamera extends OneToOneUiUIEvent {}

@immutable
class OnEnableVideo extends OneToOneUiUIEvent {}

@immutable
class OnSocketMessage extends OneToOneUiUIEvent {
  OnSocketMessage({required this.message});
  final String message;
}

@immutable
class OnSocketClose extends OneToOneUiUIEvent {
  OnSocketClose({required this.ex, required this.from});
  final String ex;
  final bool from;
}

@immutable
class OnRegister extends OneToOneUiUIEvent {}

@immutable
class OnLocalStream extends OneToOneUiUIEvent {
  OnLocalStream({required this.mediaStream});
  final MediaStream mediaStream;
}

@immutable
class OnAddRemoteStream extends OneToOneUiUIEvent {
  OnAddRemoteStream({required this.mediaStream});
  final MediaStream mediaStream;
}

@immutable
class OnRemoveRemoteStream extends OneToOneUiUIEvent {
  OnRemoveRemoteStream({required this.mediaStream});
  final MediaStream? mediaStream;
}

@immutable
class OnCloseSession extends OneToOneUiUIEvent {}